/**
 * @file capsule.c
 * @brief The implementation of the capsule interface
 * @author Wouter Horr&eacute;
 */

#include <module.h>

#include <capsulestore/capsule.h>

typedef struct {
	sos_pid_t pid;
} capsule_state_t;

// Forward declarations
static int8_t module(void *state, Message *e);
//static FavimOpCode* get_opcode_at(func_cb_ptr proto, FavimCapsule* capsule, FavimCapsuleIndex index);
static FavimCapsule* new(func_cb_ptr);

static mod_header_t mod_header SOS_MODULE_HEADER = {
	.mod_id         = FAVIM_CAPSULE_PID,
	.state_size     = sizeof(capsule_state_t),
	.num_timers     = 0,
	.num_sub_func   = 0,
	.num_prov_func  = 1,
	.module_handler = module,
	.funct = {
//		{get_opcode_at, "aac2", FAVIM_CAPSULE_PID, FAVIM_CAPSULE_GET_OPCODE_AT_FID},
		{new, "avv0", FAVIM_CAPSULE_PID, FAVIM_CAPSULE_NEW_FID},
	},
};

//! The main message handling function
static int8_t module(void *state, Message *msg)
{
    capsule_state_t *s = (capsule_state_t *) state;

    switch (msg->type){

        case MSG_INIT:
		{
			s->pid = msg->did;
			return SOS_OK;
		}


        case MSG_FINAL:
        {
			return SOS_OK;
        }


        default:
			return -EINVAL;
	}

    return SOS_OK;
}

//! Get the opcode at a specified position
//static FavimOpCode* get_opcode_at(func_cb_ptr proto, FavimCapsule * capsule, FavimCapsuleIndex index)
//{
//	//TODO implementation
//}

static FavimCapsule* new(func_cb_ptr proto)
{
	int i;
	FavimCapsule* new = (FavimCapsule *) my_malloc(sizeof(FavimCapsule),FAVIM_CAPSULE_PID);
	new->version = 0;
	for(i=0; i < ((FAVIM_GLOBAL_COUNT + 7) / 8) ; ++i){
		new->usedVars[i] = 0;
	}
	new->dataSize=2;
	new->data[0] = 0x01; //require basic lib
	new->data[1] = 0x00; //halt
	return new;
}

#ifndef _MODULE_
mod_header_ptr capsule_get_header()
{
    return sos_get_header_address(mod_header);
}
#endif

