/**
 * @file favim_constants.h
 * @brief Essential constants for FAViM
 * @author Wouter Horr&eacute;
 */

#ifndef _FAVIM_CONSTANTS_H_
#define _FAVIM_CONSTANTS_H_

#include <module.h>

//! The return codes used in FAViM
enum
{
	FAVIM_OK = SOS_OK,
	//In the event manager
	FAVIM_ERROR_TIMER_EXISTS = 1, //!< There is already a timer started with the given id
	FAVIM_ERROR_ID_INVALID = 2,
	FAVIM_ERROR_FAILED_LOCKING = 3,
};

//#include <message_types.h>
//#include "sos_constants.h"

//typedef enum {
//  MHOplaceholder,
//} MateHandlerOptions;
//
//#define ASVM_MOD_MIN_PID 230
//#define ASVM_LIB_MIN_PID 248
//#define OPCODE_BITS 5
//#define OPCODE_MASK 0x1F
//#define LIBRARY_MASK 0x07
//
//typedef enum {
//  MATE_CONTEXT_GLOBALTRIGGER	 = 3,
//  //MATE_CONTEXT_TRIGGER	 = 0, // unique("MateContextID"),
//  MATE_CONTEXT_GLOBALTIMER0	 = 17,
//  MATE_CONTEXT_TIMER0	 = 0, // unique("MateContextID"),
//  MATE_CONTEXT_GLOBALTIMER1	 = 16,
//  //MATE_CONTEXT_TIMER1	 = 2, // unique("MateContextID"),
//  MATE_CONTEXT_GLOBALONCE	 = 2,
//  MATE_CONTEXT_PUSHBUTTON	 = 1, // unique("MateContextID"),
//  MATE_CONTEXT_GLOBALREBOOT	 = 1,
//  MATE_CONTEXT_REBOOT	 = 2, // unique("MateContextID"),
//  MATE_CONTEXT_GLOBALBROADCAST	 = 32,
//  MATE_CONTEXT_CLIFF	 = 3, // unique("MateContextID"),
//  MATE_CONTEXT_NUM	 = 4, // unique("MateContextID"),
//  MATE_CONTEXT_INVALID = 255
//} MateContextID;
//typedef enum {
//  MATE_HANDLER_GLOBAL_TRIGGER	 = 3,
//  //MATE_HANDLER_TRIGGER	 = 0, // unique("MateHandlerID"),
//  MATE_HANDLER_GLOBAL_TIMER0	 = 17,
//  MATE_HANDLER_TIMER0	 = 0, // unique("MateHandlerID"),
//  MATE_HANDLER_GLOBAL_TIMER1	 = 16,
//  //MATE_HANDLER_TIMER1	 = 2, // unique("MateHandlerID"),
//  MATE_HANDLER_GLOBAL_ONCE	 = 2,
//  MATE_HANDLER_PUSHBUTTON	 = 1, // unique("MateHandlerID"),
//  MATE_HANDLER_GLOBAL_REBOOT	 = 1,
//  MATE_HANDLER_REBOOT	 = 2, // unique("MateHandlerID"),
//  MATE_HANDLER_GLOBAL_BROADCAST	 = 32,
//  MATE_HANDLER_CLIFF	 = 3, // unique("MateHandlerID"),
//  MATE_HANDLER_NUM	 = 4, // unique("MateHandlerID"),
//  MATE_HANDLER_INVALID = 255
//} MateHandlerID;
//typedef enum {
//  //MATE_CAPSULE_TRIGGER	 = 0, // unique("MateCapsuleID"),
//  MATE_CAPSULE_TIMER0	 = 0, // unique("MateCapsuleID"),
//  //MATE_CAPSULE_TIMER1	 = 2, // unique("MateCapsuleID"),
//  MATE_CAPSULE_PUSHBUTTON	 = 1, // unique("MateCapsuleID"),
//  MATE_CAPSULE_REBOOT	 = 2, // unique("MateCapsuleID"),
//  MATE_CAPSULE_CLIFF	 = 3, // unique("MateCapsuleID"),
//  MATE_CAPSULE_NUM	 = 4, //9, // unique("MateCapsuleID"),
//  MATE_CAPSULE_INVALID = 255
//} MateCapsuleID;
//
//enum {
//  MATE_CALLDEPTH    = 8,
//  MATE_OPDEPTH      = 8,
//  MATE_LOCK_COUNT   = 2, //uniqueCount("MateLock"),
//  MATE_BUF_LEN      = 8,
//  MATE_CAPSULE_SIZE = 30,//128 before
//  MATE_HANDLER_SIZE = 30,//128 before
//  MATE_CPU_QUANTUM  = 4,
//  MATE_CPU_SLICE    = 30,
//};
//
//typedef enum {
//  MATE_TYPE_NONE      = 0,
//  MATE_TYPE_BUFFER    = 1,
//  MATE_TYPE_INTEGER   = 32,
//  MATE_TYPE_MSBPHOTO  = 48,
//  MATE_TYPE_MSBTEMP   = 49,
//  MATE_TYPE_MSBMIC    = 50,
//  MATE_TYPE_MSBMAGX   = 51,
//  MATE_TYPE_MSBMAGY   = 52,
//  MATE_TYPE_MSBACCELX = 53,
//  MATE_TYPE_MSBACCELY = 54,
//  MATE_TYPE_THUM      = 55,
//  MATE_TYPE_TTEMP     = 56,
//  MATE_TYPE_TPAR      = 57,
//  MATE_TYPE_TTSR      = 58,
//  MATE_TYPE_END       = 59
//} MateDataType;
//
//typedef enum {
//  MATE_STATE_HALT,
//  MATE_STATE_WAITING,
//  MATE_STATE_READY,
//  MATE_STATE_RUN,
//  MATE_STATE_BLOCKED,
//} MateContextState;
//
//typedef enum {
//  MATE_ERROR_TRIGGERED,
//  MATE_ERROR_INVALID_RUNNABLE,
//  MATE_ERROR_STACK_UNDERFLOW,
//  MATE_ERROR_BUFFER_OVERFLOW,
//  MATE_ERROR_BUFFER_UNDERFLOW,
//  MATE_ERROR_STACK_OVERFLOW,
//  MATE_ERROR_INDEX_OUT_OF_BOUNDS,
//  MATE_ERROR_INSTRUCTION_RUNOFF,
//  MATE_ERROR_LOCK_INVALID,
//  MATE_ERROR_LOCK_STEAL,
//  MATE_ERROR_UNLOCK_INVALID,
//  MATE_ERROR_QUEUE_ENQUEUE,
//  MATE_ERROR_QUEUE_DEQUEUE,
//  MATE_ERROR_QUEUE_REMOVE,
//  MATE_ERROR_QUEUE_INVALID,
//  MATE_ERROR_RSTACK_OVERFLOW,
//  MATE_ERROR_RSTACK_UNDERFLOW,
//  MATE_ERROR_INVALID_ACCESS,
//  MATE_ERROR_TYPE_CHECK,
//  MATE_ERROR_INVALID_TYPE,
//  MATE_ERROR_INVALID_LOCK,
//  MATE_ERROR_INVALID_INSTRUCTION,
//  MATE_ERROR_INVALID_SENSOR,
//  MATE_ERROR_INVALID_HANDLER,
//  MATE_ERROR_ARITHMETIC,
//  MATE_ERROR_SENSOR_FAIL,
//} MateErrorCode;
//
//enum {
//  AM_MATEUARTMSG    = (MOD_MSG_START + 40),
//  AM_MATEBCASTMSG   = (MOD_MSG_START + 41),
//  AM_MATEROUTEMSG         = (MOD_MSG_START + 42),
//  AM_MATEVERSIONMSG       = (MOD_MSG_START + 43),
//  AM_MATEVERSIONREQUESTMSG= (MOD_MSG_START + 44),
//  AM_MATEERRORMSG         = (MOD_MSG_START + 45),
//  AM_MATECAPSULEMSG       = (MOD_MSG_START + 46),
//  AM_MATEPACKETMSG        = (MOD_MSG_START + 47),
//  AM_MATECAPSULECHUNKMSG  = (MOD_MSG_START + 48),
//  AM_MATECAPSULESTATUSMSG = (MOD_MSG_START + 49),
//};
//
//typedef enum { // instruction set
///*  OP_HALT = 	0x0,
//  OP_BCOPY = 	0x1,
//  OP_ADD = 	0x20,
//  OP_SUB = 	0x3,
//  OP_LAND = 	0x4,
//  OP_LOR = 	0x5,
//  OP_OR = 	0x6,
//  OP_AND = 	0x7,
//  OP_NOT = 	0x8,
//  OP_LNOT = 	0x9,
//  OP_DIV = 	0xa,
//  OP_BTAIL = 	0xb,
//  OP_EQV = 	0xc,
//  OP_EXP = 	0xd,
//  OP_IMP = 	0xe,
//  OP_LXOR = 	0xf,
//  OP_2PUSHC10 = 	0x10,
//  OP_3PUSHC16 = 	0x14,
//  OP_2JUMPS10 = 	0x15,
//  OP_GETLOCAL3 = 	0x4,	//4-11
//  OP_SETLOCAL3 = 	0xc,	//12-19
//  OP_UNLOCK = 	0x29,
//  OP_PUNLOCK = 	0x2a,
//  OP_BPUSH3 = 	0x2b,
//  OP_GETVAR4 = 	0x33,
//  OP_SETVAR4 = 	0x43,
//  OP_PUSHC6 = 	0x1,
//  OP_MOD = 	0x21,
//  OP_MUL = 	0x94,
//  OP_BREAD = 	0x95,
//  OP_BWRITE = 	0x96,
//  OP_POP = 	0x97,
//  OP_EQ = 	0x98,
//  OP_GTE = 	0x99,
//  OP_GT = 	0x9a,
//  OP_LT = 	0x9b,
//  OP_LTE = 	0x9c,
//  OP_NEQ = 	0x9d,
//  OP_COPY = 	0x9e,
//  OP_INV = 	0x9f,
//  OP_SOFF = 	0xa0,
//  OP_SON = 	0xa1,
//  OP_LIGHT = 	0xa2,
//  OP_TEMP = 	0xa3,
//  OP_MIC = 	0xa4,
//  OP_ACCELX = 	0xa5,
//  OP_ACCELY = 	0xa6,
//  OP_MAGX = 	0xa7,
//  OP_MAGY = 	0xa8,
//  OP_BCLEAR = 	0xa9,
//  OP_BFULL = 	0xaa,
//  OP_BSIZE = 	0xab,
//  OP_BUFSORTA = 	0xac,
//  OP_BUFSORTD = 	0xad,
//  OP_EQTYPE = 	0xae,
//  OP_ERR = 	0xaf,
//  OP_ID = 	0xb0,
//  OP_INT = 	0xb1,
//  OP_LED = 	0x2,
//  OP_RAND = 	0xb3,
//  OP_SEND = 	0xb4,
//  OP_SLEEP = 	0xb5,
//  OP_UART = 	0xb6,
//  OP_TRIGGER = 	0xb7,
//  OP_TRIGGERBUF = 	0xb8,
//  OP_SETTIMER0 = 	0x3,
//  OP_SETTIMER1 = 	0xba,
//  OP_BCAST = 	0xbb,
//  OP_BCASTBUF = 	0xbc, */
//  
//  OP_HALT = (BASICLIB_MIN_OPCODE + 0),
//  OP_PUSHC6 = (BASICLIB_MIN_OPCODE + 1),
//  OP_LED = (BASICLIB_MIN_OPCODE + 2),
//  OP_RAND = (BASICLIB_MIN_OPCODE + 3),
//  OP_GETLOCAL2 = (BASICLIB_MIN_OPCODE + 4),
//  OP_SETLOCAL2 = (BASICLIB_MIN_OPCODE + 8),
//  OP_SETTIMER0 = (BASICLIB_MIN_OPCODE + 12),
//  OP_JNZ = (BASICLIB_MIN_OPCODE + 14),
//  OP_GET_PHOTO_DATA = (BASICLIB_MIN_OPCODE + 15),
//  OP_POST = (BASICLIB_MIN_OPCODE + 16),	
//  OP_BPUSH1 = (BASICLIB_MIN_OPCODE + 17),	//17-18, two buffers	
//  OP_BAPPEND = (BASICLIB_MIN_OPCODE + 19),	//19 - BAPPEND, 
//						//20 - BAPPEND_LEAVE	
//  OP_CALL = (BASICLIB_MIN_OPCODE + 21),	
//  OP_BCLEAR = (BASICLIB_MIN_OPCODE + 22),	
//  
//  OP_ADD = (MATHLIB_MIN_OPCODE + 0),
//  OP_MOD = (MATHLIB_MIN_OPCODE + 1),
//  OP_INCR = (MATHLIB_MIN_OPCODE + 2),
//  OP_DECR = (MATHLIB_MIN_OPCODE + 3),
//  
//  OP_MOVE = (RAGOLIB_MIN_OPCODE + 0),
//  OP_TURN = (RAGOLIB_MIN_OPCODE + 1),
//  OP_PAN = (RAGOLIB_MIN_OPCODE + 2),
//  OP_TILT = (RAGOLIB_MIN_OPCODE + 3),
//  OP_SCAN = (RAGOLIB_MIN_OPCODE + 4),
//  OP_SHOW_VALUE = (RAGOLIB_MIN_OPCODE + 5),
//  OP_FIND_DISTANCE = (RAGOLIB_MIN_OPCODE + 6),
//  OP_SALUTE = (RAGOLIB_MIN_OPCODE + 7),
//  OP_FLASHLED = (RAGOLIB_MIN_OPCODE + 8),
//  OP_ENABLE_CLIFF = (RAGOLIB_MIN_OPCODE + 9),
//  OP_ENABLE_PUSHBUTTON = (RAGOLIB_MIN_OPCODE + 10),
//} MateInstruction;
//
//typedef enum { // Function identifiers
//  MFIplaceholder,
//} MateFunctionID;
//
///*
// * MVirus uses the Trickle algorithm for code propagation and maintenance.
// * A full description and evaluation of the algorithm can be found in
// *
// * Philip Levis, Neil Patel, David Culler, and Scott Shenker.
// * "Trickle: A Self-Regulating Algorithm for Code Propagation and Maintenance
// * in Wireless Sensor Networks." In Proceedings of the First USENIX/ACM
// * Symposium on Networked Systems Design and Implementation (NSDI 2004).
// *
// * A copy of the paper can be downloaded from Phil Levis' web site:
// *        http://www.cs.berkeley.edu/~pal/
// *
// * A brief description of the algorithm can be found in the comments
// * at the head of MVirus.nc.
// *
// */
//
//typedef enum {
//  /* These first two constants define the granularity at which t values
//     are calculated (in ms). Version vectors and capsules have separate
//     timers, as version timers decay (lengthen) while capsules timers
//     are constant, as they are not a continuous process.*/
//  MVIRUS_VERSION_TIMER = 100,           // The units of time (ms)
//  MVIRUS_CAPSULE_TIMER = 100,           // The units of time (ms)
//
//  /* These constants define how many times a capsule is transmitted,
//     the timer interval for Trickle suppression, and the redundancy constant
//     k. Due to inherent loss, having a repeat > 1 is preferrable, although
//     it should be small. It's better to broadcast the data twice rather
//     than require another metadata announcement to trigger another
//     transmission. It's not clear whether REDUNDANCY should be > or = to
//     REPEAT. In either case, both constants should be small (e.g, 2-4). */
//  
//  MVIRUS_CAPSULE_REPEAT = 2,            // How many times to repeat a capsule
//  MVIRUS_CAPSULE_TAU = 10,              // Capsules have a fixed tau
//  MVIRUS_CAPSULE_REDUNDANCY = 2,        // Capsule redundancy (suppression pt.)
//
//  /* These constants define the minimum and maximum tau values for
//     version vector exchange, as well as the version vector redundancy
//     constant k. Note that the tau values are in terms of multiples
//     of the TIMER value above (e.g., a MIN of 10 and a TIMER of 100
//     means a MIN of 1000 ms, or one second). */
//  MVIRUS_VERSION_TAU_MIN = 10,          // Version scaling tau minimum
//  MVIRUS_VERSION_TAU_MAX = 600,         // Version scaling tau maximum
//  MVIRUS_VERSION_REDUNDANCY = 1,        // Version redundancy (suppression pt.)
//  
//  /* These constants are all for sending data larger than a single
//     packet; they define the size of a program chunk, bitmasks, etc.*/
//  MVIRUS_CAPSULE_HEADER_SIZE = 2,
//  MVIRUS_CHUNK_SIZE = MATE_CAPSULE_SIZE + MVIRUS_CAPSULE_HEADER_SIZE,
//  MVIRUS_BITMASK_ENTRIES = ((MATE_CAPSULE_SIZE + MVIRUS_CHUNK_SIZE - 1) / MVIRUS_CHUNK_SIZE),
//  MVIRUS_BITMASK_SIZE = (MVIRUS_BITMASK_ENTRIES + 7) / 8,
//} MVirusConstants;

#endif
