%{
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <sys/socket.h>

int sossrv_connect(char* server_addr, char* server_port);

typedef struct {
  unsigned char  did;                          //!< module destination id
  unsigned char  sid;                          //!< module source id
  unsigned short daddr;                        //!< node destination address
  unsigned short saddr;                        //!< node source address
  unsigned char  type;                         //!< module specific message type
  unsigned char  len;                          //!< payload length 
  unsigned char  data[128];                    //!< actual payload
} __attribute__ ((packed)) SOS_Message_t;

typedef struct {
  long int version;
  unsigned char capsule_number;
  unsigned char piece_number;
  unsigned short capsuleLength;
  unsigned char payload[30];
} __attribute__ ((packed)) Mate_capsule_t;


int MATE_MSG_HEADER_SIZE = 8;
int SOS_MSG_HEADER_SIZE = 8;
unsigned char BASIC_LIB = 0;
unsigned char MATH_LIB = 32;
unsigned char RAGO_LIB = 64;
unsigned char TEST_LIB = 32;
//#define SOS_MSG_HEADER_SIZE (offsetof(struct SOS_Message_t, data))
//#define MATE_MSG_HEADER_SIZE (offsetof(struct Mate_capsule_t, payload))
unsigned char *data_ptr;
int fd, local = 0;
unsigned char data[200];
unsigned int i, inc;

%}


%%
INC	{inc = 1;}
MATH	{unsigned char lib = 2; data_ptr[0] |= lib;} 
RAGO	{unsigned char lib = 4; data_ptr[0] |= lib;} 
TEST	{unsigned char lib = 2; data_ptr[0] |= lib;}
HALT	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 0;}
PUSH	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 1;}
LED	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 2;}
RAND	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 3;}
GETLOCAL2 {if (inc) {inc = 0; i++;} data_ptr[i] = BASIC_LIB + 4; local = 1;}
SETLOCAL2 {if (inc) {inc = 0; i++;} data_ptr[i] = BASIC_LIB + 8; local = 1;}
SETTIMER0	{if (inc) {inc = 0; i++;} data_ptr[i] = BASIC_LIB + 12; local = 1;}
JNZ	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 14;}
GET_PHOTO_DATA	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 15;}
POST	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 16;}
BPUSH1	{if (inc) {inc = 0; i++;} data_ptr[i] = BASIC_LIB + 17; local = 1;}
BAPPEND	{if (inc) {inc = 0; i++;} data_ptr[i] = BASIC_LIB + 19; local = 1;}
CALL	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 21; }
BCLEAR	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 22; }
ADD	{if (inc) {inc = 0; i++;} data_ptr[i++] = MATH_LIB + 0;}
MOD	{if (inc) {inc = 0; i++;} data_ptr[i++] = MATH_LIB + 1;}
INCR	{if (inc) {inc = 0; i++;} data_ptr[i++] = MATH_LIB + 2;}
DECR	{if (inc) {inc = 0; i++;} data_ptr[i++] = MATH_LIB + 3;}
MOVE 	{if (inc) {inc = 0; i++;} data_ptr[i++] = RAGO_LIB + 0;}
TURN	{if (inc) {inc = 0; i++;} data_ptr[i++] = RAGO_LIB + 1;}
PAN	{if (inc) {inc = 0; i++;} data_ptr[i++] = RAGO_LIB + 2;}
TILT	{if (inc) {inc = 0; i++;} data_ptr[i++] = RAGO_LIB + 3;}
SCAN	{if (inc) {inc = 0; i++;} data_ptr[i++] = RAGO_LIB + 4;}
SHOW_VALUE	{if (inc) {inc = 0; i++;} data_ptr[i++] = RAGO_LIB + 5;}
FIND_DISTANCE	{if (inc) {inc = 0; i++;} data_ptr[i++] = RAGO_LIB + 6;}
SALUTE	{if (inc) {inc = 0; i++;} data_ptr[i++] = RAGO_LIB + 7;}
FLASHLED	{if (inc) {inc = 0; i++;} data_ptr[i++] = RAGO_LIB + 8;}
ENABLE_CLIFF	{if (inc) {inc = 0; i++;} data_ptr[i++] = RAGO_LIB + 9;}
ENABLE_PUSHBUTTON {if (inc) {inc = 0; i++;} data_ptr[i++] = RAGO_LIB + 10;}
TRIGGER {if(inc) {inc=0; i++;} data_ptr[i++] = TEST_LIB + 0;}
ONCE	{ i++; local = 0; }	//for use with SETTIMER0
REPEAT	{ data_ptr[i] += 1; i++; local = 0; }
LEAVE	{ data_ptr[i] += 1; i++; local = 0; }	//for use with BAPPEND
TAKE	{ i++; local = 0; }

[\-]*[0-9]+	{ if (!local) { 
		data_ptr[i++] = atoi(yytext);
	  } else {
		data_ptr[i] += atoi(yytext);
		i++;
		local = 0;
	 }
	}
[ \t\n]	//printf(" ");


HEADLIGHTS_ON	data_ptr[i++] = 0;
HEADLIGHTS_OFF	data_ptr[i++] = 1;
DECKLIGHTS_ON	data_ptr[i++] = 2;
DECKLIGHTS_OFF	data_ptr[i++] = 3;
BARGRAPH_ON	data_ptr[i++] = 4;
BARGRAPH_OFF	data_ptr[i++] = 5;
BLUELED_ON	data_ptr[i++] = 6;
BLUELED_OFF	data_ptr[i++] = 7;

FALSE		data_ptr[i++] = 0;
TRUE		data_ptr[i++] = 1;


%%

main( argc, argv )
int argc;
char **argv;
{
	SOS_Message_t *sos_pkt = (SOS_Message_t *)data;
	Mate_capsule_t *mate_pkt = (Mate_capsule_t *)sos_pkt->data;
	
	data_ptr = mate_pkt->payload;
	data_ptr[0] = 1;	//basic lib is always there
	FILE *version_file;
	char version_filename[50];
	int version, temp, capsule;

	//++++++++++++
	//FILE *out;
	//++++++++++++
	
	i = 0;
	inc = 1;
	
	if (argc < 4)
	{
		printf("Usage Error!\n");
		printf("send <filename> <capsule name> <server port>\n");
		return 1;
	}
	
	if (strcmp(argv[2], "timer0") == 0)
//		capsule = 0;
		capsule = 1;
	else if (strcmp(argv[2], "pushbutton") == 0)
		capsule = 1;
	else if (strcmp(argv[2], "reboot") == 0)
//		capsule = 2;
		capsule = 0;
	else if (strcmp(argv[2], "cliff") == 0)
		capsule = 3;
	else exit(printf("Wrong capsule name\n"));
	
	//open file	
	yyin = fopen( argv[1], "r" );
	if(yyin == NULL)
	{
		printf("Data file could not be opened\n");
		return 1;
	}
	
	sprintf(version_filename, "temp%d.txt", capsule);
	version_file = fopen(version_filename, "r");
	if(version_file == NULL)
	{
		printf("New version file created\n");
		version = 0;
	}
	else
	{
		if( fscanf(version_file, "%ld", &version) > 0 )
		{
			printf("version = %ld\n", version);
		}
		else
		{
			printf("Nothing written to file\n");
			version = 0;
		}
		fclose(version_file);
	}
	
	version_file = fopen(version_filename, "w");
	
	printf("writing %ld to file\n", version+1);
	fprintf(version_file, "%ld", ++version);
	
	fclose(version_file);
	
	//fd = sossrv_connect("128.97.93.31", argv[3]);
	fd = sossrv_connect("127.0.0.1", argv[3]);
	//++++++++++
	//out = fopen("compiled.txt", "w");
	//+++++++++

	yylex();

	sos_pkt->did = 192;
	sos_pkt->sid = 192;
	sos_pkt->daddr = 0xFFFF;
	sos_pkt->saddr = 0xFFFE;
	sos_pkt->type = 32;
	sos_pkt->len = MATE_MSG_HEADER_SIZE + i;

		
		 
	
	mate_pkt->version = version;
	mate_pkt->capsule_number = capsule;
	mate_pkt->piece_number = 0;
	//mate_pkt->capsuleOption = 0;
	mate_pkt->capsuleLength = i;

	for(temp = 0; temp < MATE_MSG_HEADER_SIZE+i; temp++) 
		printf("%x ", data[SOS_MSG_HEADER_SIZE+temp]);
	printf("\n");

	write(fd, data, SOS_MSG_HEADER_SIZE + MATE_MSG_HEADER_SIZE + i);
	//++++++++++
	//fwrite(data, 1, SOS_MSG_HEADER_SIZE + MATE_MSG_HEADER_SIZE + i,out);
	//fclose(out);
	//+++++++++++++
	close(fd);
}

int sossrv_connect(char* server_addr, char* server_port)
{
	int clientsockfd;
	struct sockaddr_in server_address;

	// Create the socket
	if ((clientsockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1)
	{
		printf("Error: cannot open socket");
		exit(1);
	}

	// Setup the internet address
	server_address.sin_family = AF_INET;
	server_address.sin_port = htons(atoi(server_port));
	inet_aton(server_addr, &(server_address.sin_addr));
	memset(&(server_address.sin_zero), '\0', 8);
  
	printf("Connecting to server at %s\n", inet_ntoa(server_address.sin_addr));
	printf("Connecting to port at %d\n", ntohs(server_address.sin_port));
  
	// Connect
	if (connect(clientsockfd, (struct sockaddr *)&server_address, sizeof(struct sockaddr)) == -1) 
	{
		printf("Error: cannot connect to socket");
    	exit(1);
	}
	printf("Established TCP connection ..\n");
	
	return clientsockfd;
}
