
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <sys/socket.h>

int sossrv_connect(char* server_addr, char* server_port);

typedef struct {
  unsigned char  did;                          //!< module destination id
  unsigned char  sid;                          //!< module source id
  unsigned short daddr;                        //!< node destination address
  unsigned short saddr;                        //!< node source address
  unsigned char  type;                         //!< module specific message type
  unsigned char  len;                          //!< payload length 
  unsigned char  data[128];                    //!< actual payload
} __attribute__ ((packed)) SOS_Message_t;

typedef struct {
	unsigned char nb_con;
	unsigned char piece;
	unsigned char chunk_length;
	unsigned long int version;
	unsigned char ids[];
} __attribute__ ((packed)) Favim_ContextMsg_t;


int FAVIM_CONTEXTMSG_HEADER_SIZE = 7;
int SOS_MSG_HEADER_SIZE = 8;
unsigned char *data_ptr;
int fd, local = 0;
unsigned char data[200];
unsigned int i, inc;

main( argc, argv )
int argc;
char **argv;
{
	SOS_Message_t *sos_pkt = (SOS_Message_t *)data;
	Favim_ContextMsg_t *favim_pkt = (Favim_ContextMsg_t *)sos_pkt->data;
	
	data_ptr = favim_pkt->ids;
	char version_filename[50];
	int version;
	int temp;
	int i;
	FILE * version_file;

	if (argc < 2)
	{
		printf("Usage Error!\n");
		printf("contextsend <port>\n");
		return 1;
	}
	
	sprintf(version_filename, "temp_context.txt");
	version_file = fopen(version_filename, "r");
	if(version_file == NULL)
	{
		printf("New version file created\n");
		version = 0;
	}
	else
	{
		if( fscanf(version_file, "%ld", &version) > 0 )
		{
			printf("version = %ld\n", version);
		}
		else
		{
			printf("Nothing written to file\n");
			version = 0;
		}
		fclose(version_file);
	}
	
	version_file = fopen(version_filename, "w");
	
	printf("writing %ld to file\n", version+1);
	fprintf(version_file, "%ld", ++version);
	
	fclose(version_file);

	fd = sossrv_connect("127.0.0.1", argv[1]);

	sos_pkt->did = 192;
	sos_pkt->sid = 192;
	sos_pkt->daddr = 0xFFFF;
	sos_pkt->saddr = 0xFFFE;
	sos_pkt->type = 36;
	sos_pkt->len = FAVIM_CONTEXTMSG_HEADER_SIZE + 3; //i;

		
	favim_pkt->nb_con = 3; 
	favim_pkt->piece = 0;
	favim_pkt->chunk_length = 3;
	favim_pkt->version = version;
	for(i=0; i<3; ++i){
		favim_pkt->ids[i] = i;
	}
	

	for(temp = 0; temp < FAVIM_CONTEXTMSG_HEADER_SIZE+3; temp++) 
		printf("%x ", data[SOS_MSG_HEADER_SIZE+temp]);
	printf("\n");

	write(fd, data, SOS_MSG_HEADER_SIZE + FAVIM_CONTEXTMSG_HEADER_SIZE + 3);
	close(fd);
}

int sossrv_connect(char* server_addr, char* server_port)
{
	int clientsockfd;
	struct sockaddr_in server_address;

	// Create the socket
	if ((clientsockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1)
	{
		printf("Error: cannot open socket");
		exit(1);
	}

	// Setup the internet address
	server_address.sin_family = AF_INET;
	server_address.sin_port = htons(atoi(server_port));
	inet_aton(server_addr, &(server_address.sin_addr));
	memset(&(server_address.sin_zero), '\0', 8);
  
	printf("Connecting to server at %s\n", inet_ntoa(server_address.sin_addr));
	printf("Connecting to port at %d\n", ntohs(server_address.sin_port));
  
	// Connect
	if (connect(clientsockfd, (struct sockaddr *)&server_address, sizeof(struct sockaddr)) == -1) 
	{
		printf("Error: cannot connect to socket");
    	exit(1);
	}
	printf("Established TCP connection ..\n");
	
	return clientsockfd;
}
