/** 
 * Static SOS programs must include <sos.h>
 */
#include <sos.h>
//#include <mod_pid.h>

#include <virus/virus.h>
#include <vmstore/vm.h>
#include <vmstore/vm_manager.h>
#include <vmstore/concurrency.h>
#include <vmstore/context.h>
#include <vmstore/stack.h>
#include <operationstore/library_manager.h>
#include <capsulestore/capsule.h>
#include <capsulestore/capsule_manager.h>
#include <engine/event_manager.h>
#include <engine/scheduler.h>

#ifdef SOS_SIM
#include <sim_interface.h>
#endif

mod_header_ptr testlib_get_header();

mod_header_ptr loader_get_header();
mod_header_ptr scheduler_get_header();
mod_header_ptr event_manager_get_header();
mod_header_ptr library_manager_get_header();
mod_header_ptr concurrency_get_header();
mod_header_ptr stack_get_header();
mod_header_ptr capsule_get_header();
mod_header_ptr context_get_header();
mod_header_ptr vm_get_header();
mod_header_ptr basic_lib_get_header();
mod_header_ptr capsule_manager_get_header();
mod_header_ptr virus_get_header();
mod_header_ptr vm_manager_get_header();

//sos_module_t virus_mod;
//virus_state_t virus_state;

//sos_module_t vm_man_mod;
//vm_man_state_t vm_man_state;

//sos_module_t vm_mod;
//vm_state_t vm_state;

//sos_module_t conc_mod;
//concurrency_state_t conc_state;

sos_module_t context_mod;
context_state_t context_state;

sos_module_t stack_mod;
stack_state_t stack_state;

sos_module_t lib_man_mod;
lib_man_state_t lib_man_state;

sos_module_t capsule_mod;
capsule_state_t capsule_state;

sos_module_t cap_man_mod;
capsule_manager_state_t cap_man_state;

sos_module_t sched_mod;
scheduler_state_t sched_state;

sos_module_t event_man_mod;
event_man_state_t event_man_state;

void sos_start(void)
{
		ker_register_module(loader_get_header());
//        ker_register_module(virus_get_header());
//        ker_register_module(basic_lib_get_header());
//        ker_register_module(scheduler_get_header());
//        ker_register_module(event_manager_get_header());
//        ker_register_module(library_manager_get_header());
//        ker_register_module(capsule_manager_get_header());
//        ker_register_module(capsule_get_header());
		sched_register_kernel_module(&sched_mod, scheduler_get_header(),&sched_state);
		sched_register_kernel_module(&event_man_mod, event_manager_get_header(),&event_man_state);
		sched_register_kernel_module(&lib_man_mod, library_manager_get_header(),&lib_man_state);
        ker_register_module(basic_lib_get_header());
		sched_register_kernel_module(&cap_man_mod, capsule_manager_get_header(),&cap_man_state);
		sched_register_kernel_module(&capsule_mod, capsule_get_header(),&capsule_state);
		sched_register_kernel_module(&stack_mod, stack_get_header(),&stack_state);
		sched_register_kernel_module(&context_mod, context_get_header(),&context_state);
//		sched_register_kernel_module(&conc_mod, concurrency_get_header(),&conc_state);
//		sched_register_kernel_module(&vm_mod, vm_get_header(),&vm_state);
//		sched_register_kernel_module(&vm_man_mod, vm_manager_get_header(),&vm_man_state);
//		sched_register_kernel_module(&virus_mod, virus_get_header(),&virus_state);
//        ker_register_module(stack_get_header());
//        ker_register_module(context_get_header());
        ker_register_module(concurrency_get_header());
        ker_register_module(vm_get_header());
        ker_register_module(vm_manager_get_header());
        ker_register_module(virus_get_header());
#ifdef SOS_SIM
		  module_headers[0] = testlib_get_header();
#endif
		ker_register_module(testlib_get_header());
}
