/**
 * @file capsule.h
 * @brief The Interface of a FAViM capsule
 * @author Wouter Horr&eacute;
 */

#ifndef _FAVIM_CAPSULE_H_
#define _FAVIM_CAPSULE_H_

//needed typedefs
typedef struct FavimCapsule FavimCapsule;

#include "../favim.h"

// maximum length of a capsule: 256 bytes
#define FAVIM_CAPSULE_MAX_SIZE 256

//typedef uint16_t FavimCapsuleOption;
//! The index of a favim capsule
typedef uint8_t FavimCapsuleIndex;
//! The length of a favim capsule
typedef FavimCapsuleIndex FavimCapsuleLength;
//! The version of a favim capsule
typedef uint32_t FavimCapsuleVersion;

//! A capsule in FAViM
struct FavimCapsule
{
	//FavimCapsuleOption options;
	FavimCapsuleVersion version;
	uint8_t usedVars[(FAVIM_GLOBAL_COUNT + 7) / 8];
	FavimCapsuleLength dataSize;
//	FavimOpCode data[FAVIM_CAPSULE_SIZE];
	FavimOpCode *data;
} __attribute__((packed));

enum
{
	FAVIM_CAPSULE_NEW_FID,
	FAVIM_CAPSULE_FINALIZE_FID,
};

// Typedefs needed for calling the exported functions
typedef FavimCapsule* (*favim_capsule_new_proto)(func_cb_ptr);
typedef void (*favim_capsule_finalize_proto)(func_cb_ptr, FavimCapsule*);

//! The state of the capsule module
typedef struct {
	sos_pid_t pid;
	FavimOpCode default_capsule[2];
} capsule_state_t;


//! The default capsule
//extern FavimOpCode default_capsule[];

#endif

