#ifndef _FAVIM_SCHEDULER_H_
#define _FAVIM_SCHEDULER_H_

#include "../favim.h"
#include "../vmstore/context.h"

#define FAVIM_CPU_SLICE 30

//! The function ids for the exported functions
enum
{
	FAVIM_SCHEDULER_SUBMIT_FID,
	FAVIM_SCHEDULER_OPDONE_FID,
	FAVIM_SCHEDULER_REBOOT_FID,
};

// The typedefs needed to call the function
typedef int8_t (*favim_scheduler_submit_proto)(func_cb_ptr, FavimContext*);
typedef void (*favim_scheduler_opdone_proto)(func_cb_ptr, FavimContext*);
//typedef void (*favim_scheduler_reboot_proto)(func_cb_ptr);

//! The state of the scheduler
typedef struct {
    func_cb_ptr get_library;
    func_cb_ptr get_opcode;
    func_cb_ptr get_needed_libs;
    func_cb_ptr get_library_pid;
	func_cb_ptr libs_present;
    func_cb_ptr concurrency_halt;
	sos_pid_t pid;
    FavimQueue runQueue;
    FavimContext* runningContext;
    struct {
//        uint8_t inErrorState  : 1;
//        uint8_t errorFlipFlop : 1;
        uint8_t taskRunning   : 1;
        uint8_t halted        : 1;
    } __attribute__((packed)) flags;
} scheduler_state_t;

#endif
