/**
 * @file library_manager.h
 * @brief The library manager interface
 * @author Wouter Horr&eacute;
 */

#ifndef _FAVIM_LIBRARY_MANAGER_H_
#define _FAVIM_LIBRARY_MANAGER_H_

#include "../favim.h"

typedef uint8_t FavimLibraryId;
typedef uint64_t FavimLibraryBitmask;

#define FAVIM_LIBRARY_ID_INVALID 0xff

enum
{
	FAVIM_LIB_MANAGER_LIB_PRESENT_FID,
	FAVIM_LIB_MANAGER_LIBS_PRESENT_FID,
	FAVIM_LIB_MANAGER_GET_LIBRARY_PID_FID,
};

typedef BOOL (*favim_lib_manager_lib_present_proto)(func_cb_ptr, FavimLibraryId);
typedef BOOL (*favim_lib_manager_libs_present_proto)(func_cb_ptr, FavimLibraryBitmask);
typedef uint8_t (*favim_lib_manager_get_library_pid_proto)(func_cb_ptr, FavimLibraryId);

//! The state of the library manager
typedef struct {
	func_cb_ptr trigger_event;
	sos_pid_t pid;
	FavimLibraryBitmask libraries;
} lib_man_state_t;


#endif
