#ifndef _FAVIM_CONCURRENCY_H_
#define _FAVIM_CONCURRENCY_H_

#include "../favim.h"
#include "context.h"

enum
{
	FAVIM_CONC_SUBMIT_FID,
	FAVIM_CONC_RESUME_FID,
	FAVIM_CONC_HALT_FID,
	FAVIM_CONC_YIELD_FID,
	FAVIM_CONC_ANALYSE_CAPSULE_FID,
};

typedef int8_t (*favim_concurrency_submit_proto)(func_cb_ptr, FavimContext*);
typedef int8_t (*favim_concurrency_resume_proto)(func_cb_ptr, FavimContext*);
typedef void (*favim_concurrency_halt_proto)(func_cb_ptr, FavimContext*);
typedef void (*favim_concurrency_yield_proto)(func_cb_ptr, FavimContext*);
typedef void (*favim_concurrency_analyse_capsule_proto)(func_cb_ptr, FavimVMId, FavimCapsule*);

//! The state of the concurrency manager
typedef struct {
	func_cb_ptr bytelength;
	func_cb_ptr uses_globals;
	func_cb_ptr scheduler_submit;
    func_cb_ptr get_library;
    func_cb_ptr get_opcode;
    func_cb_ptr get_needed_libs;
	func_cb_ptr lock;
	func_cb_ptr unlock;
	func_cb_ptr is_locked;
	func_cb_ptr libs_present;
    func_cb_ptr get_library_pid;
	sos_pid_t pid;
	FavimQueue readyQueue;
} concurrency_state_t;


#endif
