#ifndef _FAVIM_VM_MANAGER_H_
#define _FAVIM_VM_MANAGER_H_

typedef uint8_t FavimVMId;

#include "../favim.h"
#include "vm.h"


enum
{
	FAVIM_VM_MAN_GET_VM_FID,
	FAVIM_VM_MAN_VM_PRESENT_FID,
	FAVIM_VM_MAN_GET_VM_VERSION_FID,
};

typedef FavimVM* (*favim_vm_man_get_vm_proto)(func_cb_ptr,FavimVMId);
typedef BOOL (*favim_vm_man_vm_present_proto)(func_cb_ptr,FavimVMId);
typedef FavimVMVersion (*favim_vm_man_get_vm_version_proto)(func_cb_ptr,FavimVMId);

//! The state of the favim vm manager
typedef struct {
	func_cb_ptr vm_new;
	func_cb_ptr vm_finalize;
	func_cb_ptr vm_get_needed_libs;
	func_cb_ptr lib_man_libs_present;
	sos_pid_t pid;
	FavimVM * vms[FAVIM_VM_COUNT];
	FavimVMVersion versions[FAVIM_VM_COUNT];
} vm_man_state_t;

#endif /*VM_MANAGER_H_*/
