/**
 * @file capsule.c
 * @brief The implementation of the capsule interface
 * @author Wouter Horr&eacute;
 */

#include <module.h>

#include <capsulestore/capsule.h>

typedef struct {
	sos_pid_t pid;
} capsule_state_t;

// Forward declarations
static int8_t module(void *state, Message *e);
static FavimOpCode* get_opcode_at(func_cb_ptr proto, FavimCapsule* capsule, FavimCapsuleIndex index);

static mod_header_t mod_header SOS_MODULE_HEADER = {
	.mod_id         = FAVIM_CAPSULE_PID,
	.state_size     = sizeof(capsule_state_t),
	.num_timers     = 0,
	.num_sub_func   = 0,
	.num_prov_func  = 1,
	.module_handler = module,
	.funct = {
		{get_opcode_at, "aac2", FAVIM_CAPSULE_PID, FAVIM_CAPSULE_GET_OPCODE_AT_FID},
	},
};

//! The main message handling function
static int8_t module(void *state, Message *msg)
{
    capsule_state_t *s = (capsule_state_t *) state;

    switch (msg->type){

        case MSG_INIT:
		{
			s->pid = msg->did;
			return SOS_OK;
		}


        case MSG_FINAL:
        {
			return SOS_OK;
        }


        default:
			return -EINVAL;
	}

    return SOS_OK;
}

//! Get the opcode at a specified position
static FavimOpCode* get_opcode_at(func_cb_ptr proto, FavimCapsule * capsule, FavimCapsuleIndex index)
{
	//TODO implementation
}

#ifndef _MODULE_
mod_header_ptr capsule_get_header()
{
    return sos_get_header_address(mod_header);
}
#endif

