/**
 * @file capsule_manager.c
 * @brief The implementation of the FAViM Capsule Manager
 * @author Wouter Horr&eacute;
 */
 
#include <module.h>
#include <capsulestore/capsule_manager.h>

//! The state of the capsule manager
typedef struct {
	sos_pid_t pid;
} capsule_manager_state_t;

// Forward declarations
static int8_t module(void *state, Message *e);
static FavimCapsule* get_capsule(func_cb_ptr, FavimCapsuleId);
static int8_t add_capsule(func_cb_ptr, FavimCapsuleId, FavimCapsuleVersion, FavimCapsule*);
static int8_t remove_capsule(func_cb_ptr, FavimCapsuleId);

//! The module header of ...
static mod_header_t mod_header SOS_MODULE_HEADER = {
	.mod_id         = FAVIM_CAPSULE_MANAGER_PID,
	.state_size     = sizeof(capsule_manager_state_t),
    .num_timers     = 0,
	.num_sub_func   = 0,
	.num_prov_func  = 3,
	.module_handler = module,
	.funct = {
		{get_capsule, "ayv1", FAVIM_CAPSULE_MANAGER_PID, FAVIM_CAPSULE_MANAGER_GET_CAPSULE_FID},
		{add_capsule, "cyy3", FAVIM_CAPSULE_MANAGER_PID, FAVIM_CAPSULE_MANAGER_ADD_CAPSULE_FID},
		{remove_capsule, "cyv1", FAVIM_CAPSULE_MANAGER_PID, FAVIM_CAPSULE_MANAGER_REMOVE_CAPSULE_FID},
	},
};

//! The main message handling function
static int8_t module(void *state, Message *msg)
{
    capsule_manager_state_t *s = (capsule_manager_state_t *) state;

    switch (msg->type){

        case MSG_INIT:
		{
			s->pid = msg->did;
			return SOS_OK;
		}


        case MSG_FINAL:
        {
			return SOS_OK;
        }

        default:
			return -EINVAL;
	}

    return SOS_OK;
}

//! Get the capsule with the specified id
static FavimCapsule* get_capsule(func_cb_ptr proto, FavimCapsuleId id)
{
	//TODO implementation
}

//! Add the given capsule with the given version
static int8_t add_capsule(func_cb_ptr proto, FavimCapsuleId id, 
					FavimCapsuleVersion version, FavimCapsule* capsule)
{
	//TODO implementation
}

//! Remove the capsule with the specified id
static int8_t remove_capsule(func_cb_ptr proto, FavimCapsuleId id)
{
	//TODO implementation
}

#ifndef _MODULE_
mod_header_ptr capsule_manager_get_header()
{
    return sos_get_header_address(mod_header);
}
#endif

