/**
 * @file capsule.h
 * @brief The Interface of a FAViM capsule
 * @author Wouter Horr&eacute;
 */

#ifndef _FAVIM_CAPSULE_H_
#define _FAVIM_CAPSULE_H_

//needed typedefs
typedef struct FavimCapsule FavimCapsule;

#include "../favim.h"

#define FAVIM_CAPSULE_SIZE 30

//typedef uint16_t FavimCapsuleOption;
//! The index of a favim capsule
typedef uint16_t FavimCapsuleIndex;
//! The length of a favim capsule
typedef FavimCapsuleIndex FavimCapsuleLength;
//! The version of a favim capsule
typedef uint32_t FavimCapsuleVersion;

//! A capsule in FAViM
struct FavimCapsule
{
	//FavimCapsuleOption options;
	FavimCapsuleLength dataSize;
	FavimOpCode data[FAVIM_CAPSULE_SIZE];
} __attribute__((packed));

enum
{
	FAVIM_CAPSULE_GET_OPCODE_AT_FID = 0,
};

// Typedefs needed for calling the exported functions
typedef FavimOpCode* (*favim_capsule_get_opcode_at_proto)(func_cb_ptr, FavimCapsule*, FavimCapsuleIndex);

#endif

