/**
 * @file capsule_manager.h
 * @brief The interface of the FAViM Capsule Manager
 * @author Wouter Horr&eacute;
 */

#ifndef _FAVIM_CAPSULE_MANAGER_H_
#define _FAVIM_CAPSULE_MANAGER_H_

#include "../favim.h"
#include "capsule.h"

//! A Capsule ID
typedef uint8_t FavimCapsuleId;

//! The function id of the exported functions
enum
{
	FAVIM_CAPSULE_MANAGER_GET_CAPSULE_FID = 0,
	FAVIM_CAPSULE_MANAGER_ADD_CAPSULE_FID = 1,
	FAVIM_CAPSULE_MANAGER_REMOVE_CAPSULE_FID = 2,
};

// Typedefs needed to call the exported functions
typedef FavimCapsule* (*favim_capsule_manager_get_capsule_proto)(func_cb_ptr, FavimCapsuleId);
typedef int8_t (*favim_capsule_manager_add_capsule_proto)(func_cb_ptr, FavimCapsuleId, FavimCapsuleVersion, FavimCapsule*);
typedef int8_t (*favim_capsule_manager_remove_capsule_proto)(func_cb_ptr, FavimCapsuleId);

#endif
