/**
 * @file stack.h
 * @brief The FAViM stack interface
 * @author Wouter Horr&eacute;
 */

#ifndef _FAVIM_STACK_H_
#define _FAVIM_STACK_H_

//needed typedefs
typedef struct FavimOperandStack FavimOperandStack;

#include "../favim.h"
#include "../favim_constants.h"

#define FAVIM_STACK_DEPTH 8

//! The function ids of the exported functions
enum 
{
	FAVIM_STACK_PUSH_FID = 0,
	FAVIM_STACK_POP_FID = 1,
	FAVIM_STACK_RESET_FID = 2
};

//! A FAViM operand stack
struct FavimOperandStack
{
	uint8_t sp;
	FavimVariable stack[FAVIM_STACK_DEPTH];
} __attribute__((packed));

// Typedefs needed to call the functions
typedef int8_t (*favim_stack_push_proto)(func_cb_ptr, FavimOperandStack*, FavimVariable);
typedef FavimVariable* (*favim_stack_pop_proto)(func_cb_ptr, FavimOperandStack*);
typedef int8_t (*favim_stack_reset_proto)(func_cb_ptr, FavimOperandStack*);

#endif

