/**
 * @file capsule_manager.h
 * @brief The interface of the FAViM Capsule Manager
 * @author Wouter Horr&eacute;
 */

#ifndef _FAVIM_CAPSULE_MANAGER_H_
#define _FAVIM_CAPSULE_MANAGER_H_

typedef struct FavimCapsuleMsg FavimCapsuleMsg;

#include "../favim.h"
#include "capsule.h"

//! A Capsule ID
typedef uint8_t FavimCapsuleId;

struct FavimCapsuleMsg
{
	FavimCapsuleId id;
	FavimCapsule capsule;
};

//! The function id of the exported functions
enum
{
	FAVIM_CAPSULE_MANAGER_ADD_CAPSULE_FID,
	FAVIM_CAPSULE_MANAGER_REMOVE_CAPSULE_FID,
};

// Typedefs needed to call the exported functions
typedef int8_t (*favim_capsule_manager_add_capsule_proto)(func_cb_ptr, FavimCapsuleId, FavimCapsule*);
typedef int8_t (*favim_capsule_manager_remove_capsule_proto)(func_cb_ptr, FavimCapsuleId);

#endif
