#ifndef _FAVIM_EVENT_MANAGER_H_
#define _FAVIM_EVENT_MANAGER_H_

#include "../favim.h"
#include <sos_timer.h>

typedef uint8_t FavimEventId;
typedef uint8_t FavimTimerInterval;
typedef uint8_t FavimTimerType;
typedef struct FavimEventTimer FavimEventTimer;

//! The types of timers
enum
{
	FAVIM_TIMER_REPEAT = TIMER_REPEAT,
	FAVIM_TIMER_ONE_SHOT = TIMER_ONE_SHOT,
};

//! The function ids of the exported functions
enum
{
	FAVIM_EVENT_MANAGER_START_TIMER_FID,
	FAVIM_EVENT_MANAGER_STOP_TIMER_FID,
	FAVIM_EVENT_MANAGER_INIT_EVENT_FID,
	FAVIM_EVENT_MANAGER_TRIGGER_EVENT_FID,
};	

//! Structure representing a favim timer
struct FavimEventTimer {
	FavimEventId id;
	FavimValueVariable interval;
	FavimValueVariable ticks;
	FavimEventTimer* next;
}__attribute__((packed));

typedef int8_t (*favim_event_manager_start_timer_proto)(func_cb_ptr,FavimEventId,FavimTimerType,FavimTimerInterval);
typedef int8_t (*favim_event_manager_stop_timer_proto)(func_cb_ptr,FavimEventId);
//typedef int8_t (*favim_event_manager_init_event_proto)(func_cb_ptr,FavimEventId);
typedef int8_t (*favim_event_manager_trigger_event_proto)(func_cb_ptr,FavimEventId);

#endif
