/*
 * Copyright (c) 2006, Wouter Horré
 * All rights reserved
 * 
 * See LICENSE for details
 */
#ifndef _DAVIM_SCHEDULER_H_
#define _DAVIM_SCHEDULER_H_

#include "../davim.h"
#include "../vmstore/context.h"

#define DAVIM_CPU_SLICE 30

//! The function ids for the exported functions
enum
{
	DAVIM_SCHEDULER_SUBMIT_FID,
	DAVIM_SCHEDULER_OPDONE_FID,
//	DAVIM_SCHEDULER_BLOCK_FID,
//	DAVIM_SCHEDULER_UNBLOCK_FID,
};

// The typedefs needed to call the function
typedef int8_t (*davim_scheduler_submit_proto)(func_cb_ptr, DavimContext*);
typedef void (*davim_scheduler_opdone_proto)(func_cb_ptr, DavimContext*);
//typedef void (*davim_scheduler_block_proto)(func_cb_ptr, DavimContext*);
//typedef void (*davim_scheduler_unblock_proto)(func_cb_ptr, DavimContext*);
//typedef void (*davim_scheduler_reboot_proto)(func_cb_ptr);

//! The state of the scheduler
typedef struct {
    func_cb_ptr get_library;
    func_cb_ptr get_opcode;
    func_cb_ptr get_needed_libs;
    func_cb_ptr get_library_pid;
	func_cb_ptr libs_present;
    func_cb_ptr concurrency_halt;
    func_cb_ptr concurrency_resume;
    func_cb_ptr concurrency_yield;
	sos_pid_t pid;
    DavimQueue runQueue;
    DavimContext* runningContext;
    struct {
//        uint8_t inErrorState  : 1;
//        uint8_t errorFlipFlop : 1;
        uint8_t taskRunning   : 1;
        uint8_t halted        : 1;
    } __attribute__((packed)) flags;
} scheduler_state_t;

#endif
