/*
 * Copyright (c) 2006, Wouter Horré
 * All rights reserved
 * 
 * See LICENSE for details
 */
#ifndef _DAVIM_LIBRARY_H_
#define _DAVIM_LIBRARY_H_

#include "../davim.h"
#include "library_manager.h"
#include "../vmstore/context.h"

typedef struct DavimExecutionMsg DavimExecutionMsg;

struct DavimExecutionMsg {
	DavimContext* context;
	uint8_t opcode;
}__attribute__((packed));

enum {
	DAVIM_LIB_BYTELENGTH_FID,
	DAVIM_LIB_USES_GLOBALS_FID,
};

// typedefs needed to call the exported functions
typedef uint8_t (*davim_lib_bytelength_proto)(func_cb_ptr, DavimOpCode);
typedef void (*davim_lib_uses_globals_proto)(func_cb_ptr, DavimOpCode, uint8_t*);

#endif 
