/*
 * Copyright (c) 2006, Wouter Horré
 * All rights reserved
 * 
 * See LICENSE for details
 */
/**
 * @file library_manager.h
 * @brief The library manager interface
 * @author Wouter Horr&eacute;
 */

#ifndef _DAVIM_LIBRARY_MANAGER_H_
#define _DAVIM_LIBRARY_MANAGER_H_

#include "../davim.h"

typedef uint8_t DavimLibraryId;
typedef uint64_t DavimLibraryBitmask;

#define DAVIM_LIBRARY_ID_INVALID 0xff

enum
{
	DAVIM_LIB_MANAGER_LIB_PRESENT_FID,
	DAVIM_LIB_MANAGER_LIBS_PRESENT_FID,
	DAVIM_LIB_MANAGER_GET_LIBRARY_PID_FID,
};

typedef BOOL (*davim_lib_manager_lib_present_proto)(func_cb_ptr, DavimLibraryId);
typedef BOOL (*davim_lib_manager_libs_present_proto)(func_cb_ptr, DavimLibraryBitmask);
typedef uint8_t (*davim_lib_manager_get_library_pid_proto)(func_cb_ptr, DavimLibraryId);

//! The state of the library manager
typedef struct {
	func_cb_ptr trigger_event;
	sos_pid_t pid;
	DavimLibraryBitmask libraries;
} lib_man_state_t;


#endif
