/*
 * Copyright (c) 2006, Wouter Horré
 * All rights reserved
 * 
 * See LICENSE for details
 */
#ifndef _DAVIM_CONCURRENCY_H_
#define _DAVIM_CONCURRENCY_H_

#include "../davim.h"
#include "context.h"

enum
{
	DAVIM_CONC_SUBMIT_FID,
	DAVIM_CONC_RESUME_FID,
	DAVIM_CONC_HALT_FID,
	DAVIM_CONC_YIELD_FID,
	DAVIM_CONC_ANALYSE_CAPSULE_FID,
};

typedef int8_t (*davim_concurrency_submit_proto)(func_cb_ptr, DavimContext*);
typedef int8_t (*davim_concurrency_resume_proto)(func_cb_ptr, DavimContext*);
typedef void (*davim_concurrency_halt_proto)(func_cb_ptr, DavimContext*);
typedef void (*davim_concurrency_yield_proto)(func_cb_ptr, DavimContext*);
typedef void (*davim_concurrency_analyse_capsule_proto)(func_cb_ptr, DavimVMId, DavimCapsule*);

//! The state of the concurrency manager
typedef struct {
	func_cb_ptr bytelength;
	func_cb_ptr uses_globals;
	func_cb_ptr scheduler_submit;
    func_cb_ptr get_library;
    func_cb_ptr get_opcode;
    func_cb_ptr get_needed_libs;
	func_cb_ptr lock;
	func_cb_ptr unlock;
	func_cb_ptr is_locked;
	func_cb_ptr libs_present;
    func_cb_ptr get_library_pid;
	sos_pid_t pid;
	DavimQueue readyQueue;
} concurrency_state_t;


#endif
