/*
 * Copyright (c) 2006, Wouter Horré
 * All rights reserved
 * 
 * See LICENSE for details
 */
#ifndef _DAVIM_VM_MANAGER_H_
#define _DAVIM_VM_MANAGER_H_

typedef uint8_t DavimVMId;

#include "../davim.h"
#include "vm.h"


enum
{
	DAVIM_VM_MAN_GET_VM_FID,
	DAVIM_VM_MAN_VM_PRESENT_FID,
	DAVIM_VM_MAN_GET_VM_VERSION_FID,
};

typedef DavimVM* (*davim_vm_man_get_vm_proto)(func_cb_ptr,DavimVMId);
typedef BOOL (*davim_vm_man_vm_present_proto)(func_cb_ptr,DavimVMId);
typedef DavimVMVersion (*davim_vm_man_get_vm_version_proto)(func_cb_ptr,DavimVMId);

//! The state of the davim vm manager
typedef struct {
	func_cb_ptr vm_new;
	func_cb_ptr vm_finalize;
	func_cb_ptr vm_get_needed_libs;
	func_cb_ptr lib_man_libs_present;
	sos_pid_t pid;
	DavimVM * vms[DAVIM_VM_COUNT];
	DavimVMVersion versions[DAVIM_VM_COUNT];
} vm_man_state_t;

#endif /*VM_MANAGER_H_*/
