/*
 * Copyright (c) 2006, Wouter Horré
 * All rights reserved
 * 
 * See LICENSE for details
 */
/**
 * @file template.c
 * @brief A template
 * @author Wouter Horr&eacute;
 */
 
#include <module.h>

//! The state ...
typedef struct {
	sos_pid_t pid;
} app_state_t;

// Forward declarations
static int8_t module(void *state, Message *e);

//! The module header of ...
static mod_header_t mod_header SOS_MODULE_HEADER = {
	.mod_id         = DFLT_APP_ID0,
	.state_size     = sizeof(app_state_t),
	.platform_type  = HW_TYPE /* or PLATFORM_ANY */,
	.processor_type = MCU_TYPE,
	.code_id			= ehtons(DFLT_APP_ID0),
    .num_timers     = 0,
	.num_sub_func   = 0,
	.num_prov_func  = 0,
	.module_handler = module,
};

//! The main message handling function
static int8_t module(void *state, Message *msg)
{
    app_state_t *s = (app_state_t *) state;

    switch (msg->type){

        case MSG_INIT:
		{
			s->pid = msg->did;
			return SOS_OK;
		}


        case MSG_FINAL:
        {
			return SOS_OK;
        }

        default:
			return -EINVAL;
	}

    return SOS_OK;
}

#ifndef _MODULE_
// TODO: rename module_template_get_header() to <module_name>_get_header() 
// to avoid name collision.  
mod_header_ptr module_template_get_header()
{
    return sos_get_header_address(mod_header);
}
#endif

