/*
 * Copyright (c) 2006, Wouter Horré
 * All rights reserved
 * 
 * See LICENSE for details
 */
%{
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <errno.h>
#include <string.h>
//#include <netdb.h>
//#include <fcntl.h>
//#include <netinet/in.h>
//#include <sys/socket.h>

unsigned char BASIC_LIB = 0;
unsigned char NET_LIB = 32;
unsigned char TEST_LIB = 32;
unsigned char *data_ptr;
int local = 0;
unsigned char data[100]; // make this big enough, we support only 30 bytes for now
unsigned int i, inc;

%}


%%
INC	{inc = 1;}
TEST {unsigned char lib = 2; data_ptr[0] |= lib;}
NET {unsigned char lib = 2; data_ptr[0] |= lib;}
HALT	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 0;}
PUSH	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 1;}
LED	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 2;}
POST_NET {if (inc) {inc = 0; i++;} data_ptr[i++] = NET_LIB + 0;}
RAND	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 3;}
GETLOCAL2 {if (inc) {inc = 0; i++;} data_ptr[i] = BASIC_LIB + 4; local = 1;}
SETLOCAL2 {if (inc) {inc = 0; i++;} data_ptr[i] = BASIC_LIB + 8; local = 1;}
SETTIMER0	{if (inc) {inc = 0; i++;} data_ptr[i] = BASIC_LIB + 12; local = 1;}
JNZ	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 14;}
GET_PHOTO_DATA	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 15;}
POST	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 16;}
BPUSH1	{if (inc) {inc = 0; i++;} data_ptr[i] = BASIC_LIB + 17; local = 1;}
BAPPEND	{if (inc) {inc = 0; i++;} data_ptr[i] = BASIC_LIB + 19; local = 1;}
CALL	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 21; }
BCLEAR	{if (inc) {inc = 0; i++;} data_ptr[i++] = BASIC_LIB + 22; }
TRIGGER {if(inc) {inc=0; i++;} data_ptr[i++] = TEST_LIB + 0;}
ONCE	{ i++; local = 0; }	//for use with SETTIMER0
REPEAT	{ data_ptr[i] += 1; i++; local = 0; }
LEAVE	{ data_ptr[i] += 1; i++; local = 0; }	//for use with BAPPEND
TAKE	{ i++; local = 0; }

[\-]*[0-9]+	{ if (!local) { 
		data_ptr[i++] = atoi(yytext);
	  } else {
		data_ptr[i] += atoi(yytext);
		i++;
		local = 0;
	 }
	}
[ \t\n]	//printf(" ");


FALSE		data_ptr[i++] = 0;
TRUE		data_ptr[i++] = 1;


%%

main( argc, argv )
int argc;
char **argv;
{
	data_ptr = data;
	data_ptr[0] = 1;	//basic lib is always there

	FILE *out;
	
	i = 0;
	inc = 1;
	
	if (argc < 3)
	{
		printf("Usage Error!\n");
		printf("%s <inputfile> <outputfile>\n", argv[0]);
		return 1;
	}
	
	//open file	
	yyin = fopen( argv[1], "r" );
	if(yyin == NULL)
	{
		printf("Data file could not be opened\n");
		return 1;
	}
	
	out = fopen(argv[2], "w");

	yylex();

	fwrite(data, 1, i, out);
	fclose(out);
}
