class Mote:
	def __init__(self,id):
		self.id = id
		self.light = 0
		self.subscribers = []

	def getId(self):
		return self.id

	def switchLightOn(self):
		self.light = 750
		self.update()

	def switchLightOff(self):
		self.light = 0
		self.update()

	def setLight(self, value):
		self.light = value
		self.update()

	def getLight(self):
		return self.light

	def isLightOn(self):
		return (self.light >= 700)

	def subscribe(self, func):
		self.subscribers.append(func)

	def update(self):
		for func in self.subscribers:
			func(self)

class Network:
	def __init__(self, nbMotes):
		self.motes = []
		for i in range(1,nbMotes+1):
			self.motes.append(Mote(i))

	def getMotes(self):
		return self.motes
	
	def getMote(self, id):
		for mote in self.motes:
			if mote.id==id:
				return mote

	def addMote(self, id):
		self.motes.append(Mote(id))

	def delMote(self, id):
		self.motes = filter(lambda x: x.getId()!=id, self.motes)

	def subscribeAll(self, func):
		for mote in self.motes:
			mote.subscribe(func)
