from twisted.internet.protocol import Protocol
from twisted.internet.protocol import ClientFactory
from SOSPacket import SOSPacket
from sys import stdout
import sys
import struct

class DavimProtocol(Protocol):
	def __init__(self):
		self.subscribers = []
		
	def dataReceived(self, data):
		print "Data received: ",
		for char in data:
			(x,) = struct.unpack("B",char)
			print x,
		print
		self.update(SOSPacket(data))
	
	def subscribe(self,func):
		self.subscribers.append(func)
	
	def update(self, packet):
		for func in self.subscribers:
			func(packet)

class DavimClientFactory(ClientFactory):
	def __init__(self):
		self.subscribers = []
		
	def startedConnecting(self, connector):
		print 'Started to connect.'

	def buildProtocol(self, addr):
		print 'Connected.'
		self.protocol = DavimProtocol()
		for func in self.subscribers:
			self.protocol.subscribe(func)
		return self.protocol

	def clientConnectionLost(self, connector, reason):
		print 'Lost connection. Reason:', reason

	def clienConnectionFailed(self, connector, reason):
		print 'Connection failed. Reason:', reason

	def subscribe(self, func):
		self.subscribers.append(func)
