from struct import unpack

class SOSPacket:
	def __init__(self, data):
		(self.destmod,) = unpack("B",data[0:1])
		(self.srcmod,) = unpack("B",data[1:2])
		(self.destaddr,) = unpack("H",data[2:4])
		(self.srcaddr,) = unpack("H",data[4:6])
		(self.type,) = unpack("B",data[6:7])
		self.data = data[8:]

	def str(self):
		string = 'Source: %i (%i)\nDestination: %i (%i)\nType: %i\nLength: %i\n' % \
			(self.srcaddr,self.srcmod,self.destaddr,self.destmod,self.type,len(self.data))
		for char in self.data:
			(x,) = unpack("B",char)
			string = string + str(x) + ' '
		string = string + '\n\n'
		return string
